const uuid_generator = require("uuid");
const BlindSignature = require("blind-signatures");
const BigInteger = require("jsbn").BigInteger;
const paypal_client = require("@paypal/paypal-js");

var encrypted_sales_receipt = [];
var encrypted_sales_receipt_r = [];

one_generate_encrypted_sales_receipt();

function one_generate_encrypted_sales_receipt() {
  let current_step_container = document.getElementById(
    "generate-sales-receipt"
  );
  let next_step_container = document.getElementById("execute-payment");

  let amount = document.querySelector("input[name=amount]").value;
  let N = document.querySelector("input[name=public_key_n]").value;
  let E = document.querySelector("input[name=public_key_e]").value;

  for (let i = 0; i < amount; i++) {
    let uuid = uuid_generator.v4();

    let { blinded, r } = BlindSignature.blind({
      message: uuid,
      N: N,
      E: E,
    });
    encrypted_sales_receipt.push(blinded.toString());
    encrypted_sales_receipt_r.push(r.toString());
  }

  current_step_container.classList.remove("current");
  current_step_container.classList.add("finished");
  next_step_container.classList.add("current");
}

function two_execute_payment(provider) {}

function execute_payment_paypal(e) {
  let paypal_payment_option_button = document.getElementById(
    "payment_method_paypal"
  );

  paypal_payment_option_button.dataset.active = true;
  let client_id = paypal_payment_option_button.dataset.client_id;
  paypal_client
    .loadScript({
      "client-id": client_id,
      currency: "EUR",
    })
    .then((paypal) => {
      paypal
        .Buttons({
          createOrder: (data, actions) => {
            return fetch("/checkout/payment/order/paypal", {
              method: "POST",
              headers: {
                "Content-Type": "application/json;charset=utf-8",
              },
              body: JSON.stringify({
                order_id: document.querySelector("input[name=order_id]").value,
                amount: document.querySelector("input[name=amount]").value,
                unit_size: document.querySelector("input[name=unit_size]"),
                price_per_unit:
                  document.querySelector("input[name=price]").value,
                public_key_n: document.querySelector("input[name=public_key_n]")
                  .value,
                public_key_e: document.querySelector("input[name=public_key_e]")
                  .value,
                integrity: document.querySelector("input[name=integrity]")
                  .value,
                encrypted_sales_receipts: encrypted_sales_receipt,
              }),
            })
              .then((response) => response.json())
              .then((order) => order.id);
          },
        })
        .render("#payment-information");
    })
    .catch((err) => {
      // ToDo Handle error
      console.error("failed to load the PayPal JS SDK script", err);
    });
}

document
  .getElementById("payment_method_paypal")
  .addEventListener("click", execute_payment_paypal);
